! $Id: test_color_factors.f90 1941 2010-03-01 16:45:48Z ohl $
! driver.f90 -- O'Mega self test driver
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Copyright (C) 1999-2009 by 
!     Wolfgang Kilian <kilian@hep.physik.uni-siegen.de>
!     Thorsten Ohl <ohl@physik.uni-wuerzburg.de>
!     Juergen Reuter <juergen.reuter@physik.uni-freiburg.de>
!
! WHIZARD is free software; you can redistribute it and/or modify it
! under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2, or (at your option)
! any later version.
!
! WHIZARD is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

program test_color_factors

  use kinds
  use omega_color
  use parameters_qcd
  use amplitude_color_factors

  type(omega_color_factor), allocatable :: cf(:)
  real(kind=default), parameter :: NC = 3
  integer :: n_cfactors

  n_cfactors = number_color_factors ()
  allocate (cf(n_cfactors))

  call init_parameters
  call color_factors (cf)

  call expect (real (cf(1)%factor), -1.0_double, 1)
  call expect (real (cf(2)%factor),  NC**2,      1)

  stop 0

  contains

    subroutine expect (x, y, tolerance)
      real(kind=default), intent(in) :: x, y
      integer, intent(in) :: tolerance
      if (abs (x - y) .gt. tolerance * epsilon (max (x, y))) then
         stop 1
      end if
    end subroutine expect

end program test_color_factors

